/**********************************************************************

	--- Dlgedit generated file ---

	File: conf.cpp
	Last generated: Wed Aug 27 22:07:47 1997

 *********************************************************************/

#include <stdio.h>

#include "tamaga.h"
#include "lwin.h"
#include "conf.h"
#include <qlabel.h>
#include <qtstream.h>

#define Inherited confData

float tfv[] = { 0, TIMEMULT/2.0, TIMEMULT, 2.0*TIMEMULT, 5.0*TIMEMULT,
	8.0*TIMEMULT, 0 };

conf::conf( QWidget* parent, const char* name ) : Inherited( parent, name )
{
 setCaption( "Configure" );

 lcspeed=TL_TICK;
 //tfact=TIMEMULT;
 menuvis=1;
 stmenuvis=1;
 dbgreq=0;
 sound=1;
 resetreq=0;
 tflevel=2;
}

void conf::helpClicked()
{
#ifdef USEKDE
 app->invokeHTMLHelp("ktamaga/configure.html", "");
#else
 QMessageBox::message("Hey, You!","For help, read the included HTML files.","OK");
#endif   
}

int conf::load()
{
 printf("Loading settings...\n");
#ifdef USEKDE
 KConfig *cf = KApplication::getKApplication()->getConfig();

 cf->setGroup("Settings");
 lcspeed=cf->readNumEntry("LCDSpeed",TL_TICK);
 stmenuvis=cf->readNumEntry("MenuVisible",1);
 sound=cf->readNumEntry("Sound",1);
 tflevel=cf->readNumEntry("TimeScale",2);
 menuvis=stmenuvis;
 tfact=tfv[tflevel];
#else
 QString s;
 QFile f;

 s=getenv("HOME");
 CHECK_PTR(s);
 s+=TAMXRCFILE;
 f.setName(s);
 char buf[100];

 if (f.open(IO_Raw|IO_ReadOnly)) {
  f.readLine(buf,99); lcspeed = atoi(buf);
  f.readLine(buf,99); stmenuvis = atoi(buf);
  f.readLine(buf,99); sound = atoi(buf);
  f.readLine(buf,99); tflevel = atoi(buf);
  f.close();
  menuvis=stmenuvis;
  tfact=tfv[tflevel];
 } else {
  lcspeed=TL_TICK;
  stmenuvis=1;
  sound=1;
  tflevel=2;
  menuvis=stmenuvis;
  tfact=tfv[tflevel];
 }
                     
#endif
 return 1;
}

int conf::save()
{ 
#ifdef USEKDE
 QString s;
 KConfig *cf = KApplication::getKApplication()->getConfig();

 cf->setGroup("Settings");
 cf->writeEntry("LCDSpeed",s.setNum(lcspeed));
 cf->writeEntry("MenuVisible",s.setNum(stmenuvis));
 cf->writeEntry("Sound",s.setNum(sound));
 cf->writeEntry("TimeScale",s.setNum(tflevel));
 cf->sync();
#else

 QString s;
 QFile f;

 s=getenv("HOME");
 CHECK_PTR(s);
 s+=TAMXRCFILE;
 f.setName(s);
 if (f.open(IO_Raw|IO_ReadWrite|IO_Truncate)) {
  QTextStream ts( &f );

  ts << lcspeed << "\n";
  ts << stmenuvis << "\n";
  ts << sound << "\n";
  ts << tflevel << "\n";
  f.close();
 }

#endif
 return 1;
}

void conf::prep( void )
{
 lcs1->setChecked(lcspeed==TL_TICK);
 lcs2->setChecked(lcspeed==300);
 lcs3->setChecked(lcspeed==200);
 mvt->setChecked(stmenuvis);
 snd->setChecked(sound);

 ts1->setChecked(tfact==tfv[1]);
 ts2->setChecked(tfact==tfv[2]);
 ts3->setChecked(tfact==tfv[3]);
 ts4->setChecked(tfact==tfv[4]);
 ts5->setChecked(tfact==tfv[5]);
 //ts6->setChecked(tfact==tfv[3]);
 //scin->setEnabled(0);
}

void conf::okClicked()
{
 if (lcs1->isChecked()) lcspeed=TL_TICK;
  else if (lcs2->isChecked()) lcspeed=300;
   else lcspeed=200;

 if (ts1->isChecked()) tflevel=1;
  else if (ts2->isChecked()) tflevel=2;
   else if (ts3->isChecked()) tflevel=3;
    else if (ts4->isChecked()) tflevel=4;
     else if (ts5->isChecked()) tflevel=5;
 tfact=tfv[tflevel];

 stmenuvis=mvt->isChecked();
 sound=snd->isChecked();

 save();
 
 emit accept();
}

void conf::cancelClicked()
{
 emit reject(); 
}

void conf::debug1()
{ 
// printf("Debug1\n");
 dbgreq=1;

 emit accept();
}

void conf::debug2()
{ 
// printf("Debug2\n");
 dbgreq=2;

 emit accept();
}

void conf::resetClicked()
{ 
 dlgsel d(this,"Sure?","Are you sure you want to reset your tamagotchi?");
 if ( d.exec() ) {
  printf("yep...\n");
  resetreq=1;

  emit accept();
 }
}

conf::~conf()
{
}

//---------------------------

dlgsel::dlgsel( QWidget *parent, const char *name, char *txt ) 
 : QDialog(parent,name,TRUE)
{
 QPushButton *ok, *cancel;
 QLabel *l;

 setCaption(name);
 l = new QLabel(txt,this);
 l->setGeometry(10,10,200,30);
 l->setAlignment( 1316 );

 ok = new QPushButton("Ok",this);
 ok->setGeometry(125,50,90,30);
 cancel = new QPushButton("Cancel",this);
 cancel->setGeometry(10,50,90,30);

 connect( ok, SIGNAL(clicked()), SLOT(accept()) );
 connect( cancel, SIGNAL(clicked()), SLOT(reject()) );
}
