/****************************************************************
**
**
****************************************************************/

#include "lwin.h"

//---------------------------------------------------
void clwin::dbgWrite() { scr->debugOut(); }
void clwin::dbgCancel() 
{
 scr->setDebug(0);
 setButt(BS_NORMAL);
 scr->setSNorm(AN_NORML);
 scr->setNormal();
 app_pause=0;
}
void clwin::dbgPrev() { scr->debugPrev(); }
void clwin::dbgNext() { scr->debugNext(); }
void clwin::dbgLeft() { scr->debugMove(-1,0); }
void clwin::dbgUp()   { scr->debugMove(0,-1); }
void clwin::dbgDown() { scr->debugMove(0, 1); }
void clwin::dbgRight(){ scr->debugMove(1, 0); }
//----------------------------------------------------

void clwin::feedMeal()
{
 setButt( BS_NORMAL );
 if (((randx(1,10)<=2) && !st.hungry) || (st.bad)) { // test
  scr->setState(AN_NEGATIVE);
  st.bad=1;
  return;
 }

 if (st.hungry>3) {
  scr->setState(AN_NEGATIVE);
  return;
 }

 scr->setState(AN_EATMEAL);
 st.hungry+=2;
 st.wgt++;
 if (ss.neat==SPAUSE) ss.neat=SREINIT;
 if (ss.ars & AR_HUNGRY) ss.ars^=AR_HUNGRY;
}

void clwin::feedSnack()
{
 setButt( BS_NORMAL );
 if (((randx(1,10)<=2) && !st.hungry) || (st.bad)) {// test  
  scr->setState(AN_NEGATIVE);
  st.bad=1;
  return;
 }

 if (st.hungry>3) {
  scr->setState(AN_NEGATIVE);
  return;
 }

 scr->setState(AN_EATSNACK);
 st.hungry++;
 st.happy++;
 st.wgt+=2;
 if (ss.neat==SPAUSE) ss.neat=SREINIT;
 if (ss.ars & AR_HUNGRY) ss.ars^=AR_HUNGRY;
}

void clwin::feedCancel()
{
 //printf("[FeedCancel]\n");
 setButt( BS_NORMAL );
}

//---------------

void clwin::gameCancel()
{
 setButt( BS_NORMAL );
 scr->setSNorm(AN_NORML);
 scr->setNormal();
}

void clwin::gameLeft()
{
 int dr=randx(0,11)%2;

 if (!scr->isPlaying())
  return;

 addContGame( (dr==0) );
 scr->setPlays(dr,0);
 scr->setState(AN_PLAYRES);
}

void clwin::gameRight()
{
 int dr=randx(0,11)%2;

 if (!scr->isPlaying())
  return;

 addContGame( (dr==1) );
 scr->setPlays(dr,1);
 scr->setState(AN_PLAYRES);
}

void clwin::addContGame( int pos )
{
 ngame++;
 if (pos) ghit++;
 if (ngame>=5) {
  streq=AN_GAMERES;
  scr->setGameres(ghit,ngame-ghit);
  if (ghit>2) st.happy+=2; else st.happy--;
  ngame=0; ghit=0;
  st.wgt--;
 }
}

//---------------

void clwin::feedClicked()
{
 if (!scr->isNormal())
  return;
 
 setButt( BS_FEED );
}

void clwin::lightsClicked()
{
 if (st.lights) {
  if (st.sleeping) {
   st.lights=0;
   scr->setSNorm(AN_DARK);
   scr->setNormal();
   //scr->setState(AN_DARK); 
  }
 } else {
  scr->setSNorm(st.sleeping ? AN_SLEEP : AN_NORML);
  scr->setNormal();
  st.lights=1;
 } 
}

void clwin::gameClicked()
{
 if (!scr->isNormal())
  return;
 ngame=0; ghit=0;
 setButt( BS_PLAY );
 scr->setSNorm(AN_PLAY);
 scr->setState(AN_GAMESTART);
}

void clwin::medicalClicked()
{
 if (st.ill==0) return; 

 st.ill--;
 st.happy++;

 if (st.ill==0) {
  scr->setIll(st.ill);
  scr->setState(AN_HAPPY);
  ss.nill=SREINIT;
  if (ss.ars & AR_ILL) ss.ars^=AR_ILL;
 }
}

void clwin::toiletClicked()
{
 if (!st.poop) return;
 
 scr->setState(AN_CLEANUP);
 st.poop=0; ss.npoop=SREINIT;
 scr->setPoop(0);
 if (ss.ars & AR_MESS) ss.ars^=AR_MESS;
 streq=AN_HAPPY;
 st.happy++;
}

void clwin::statusClicked()
{
 scr->setInfoAnim(st.age, st.wgt, st.hungry, st.discl, st.happy );
 scr->setState(AN_INFO);
}

void clwin::teachClicked()
{
 if ((ss.ars & AR_NOREASON) || (st.bad)) { 
  // the rigth branch

  if (ss.ars&AR_NOREASON) ss.ars^=AR_NOREASON;
  st.discl+=3;
  st.bad=0;
  st.invdispl--;
  st.miscare--;
  setAttButt(0);
 } else {
  if (st.discl>0)
   st.discl-=2;
  if (st.discl<0)
   st.discl=0;
  scr->setState(AN_UNHAPPY);
  st.happy--;
  st.discl-=2;
  st.invdispl+=3;
  st.miscare+=2;
 }
 st.nodispl--;
}

void clwin::attentionClicked()
{
 //scr->setPhase(++st.phase);
 //scr->setNormal();
}

void clwin::resizeEvent( QResizeEvent * )
{
 ;
}
